/**
 * @license jquery.panzoom.js v1.4.1
 * Updated: Mon Aug 12 2013
 * Add pan and zoom functionality to any element
 * Copyright (c) 2013 timmy willison
 * Released under the MIT license
 * https://github.com/timmywil/jquery.panzoom/blob/master/MIT-License.txt
 */
!function(a,b){"function"==typeof define&&define.amd?define(["jquery"],b):b(a.jQuery)}(this,function(a){"use strict";function b(b){var c={range:!0,animate:!0};return"boolean"==typeof b?c.animate=b:a.extend(c,b),c}var c={props:["touches","pageX","pageY"],filter:function(a,b){var c;return!b.pageX&&b.touches&&(c=b.touches[0])&&(a.pageX=c.pageX,a.pageY=c.pageY),a}};a.each(["touchstart","touchmove","touchend"],function(b,d){a.event.fixHooks[d]=c});var d="__pz__",e=Array.prototype.slice,f=/([A-Z])/g,g=/^http:[\w\.\/]+svg$/,h="(\\-?[\\d\\.e]+)",i="\\,?\\s*",j=new RegExp("^matrix\\("+h+i+h+i+h+i+h+i+h+i+h+"\\)$"),k=function(b,c){1!==b.nodeType&&a.error("Panzoom called on non-Element node"),a.contains(document,b)||a.error("Panzoom element must be attached to the document");var e=a.data(b,d);if(e)return e;if(!(this instanceof k))return new k(b,c);this.options=c=a.extend({},k.defaults,c),this.elem=b;var h=this.$elem=a(b);this.$parent=h.parent(),this.isSVG=g.test(b.namespaceURI)&&"svg"!==b.nodeName.toLowerCase(),this.panning=!1,this._buildTransform(),this._transform=a.cssProps.transform.replace(f,"-$1").toLowerCase(),this._buildTransition(),this._buildContain();var i=a(),j=this;a.each(["$zoomIn","$zoomOut","$zoomRange","$reset"],function(a,b){j[b]=c[b]||i}),this.enable(),a.data(b,d,this)};return k.rmatrix=j,k.defaults={eventNamespace:".panzoom",transition:!0,cursor:"move",disablePan:!1,disableZoom:!1,increment:.3,minScale:.4,maxScale:5,duration:200,easing:"ease-in-out",contain:!1},k.prototype={constructor:k,instance:function(){return this},enable:function(){this._unbind(),this._initStyle(),this._bind(),this.disabled=!1},disable:function(){this.disabled=!0,this._resetStyle(),this._unbind()},isDisabled:function(){return this.disabled},destroy:function(){this.disable(),a.removeData(this.elem,d)},reset:function(a){a=b(a);var c=this.setMatrix(this._origTransform,a);a.silent||this._trigger("reset",c)},resetZoom:function(a){a=b(a);var c=this.getMatrix(this._origTransform);a.dValue=c[3],this.zoom(c[0],a)},resetPan:function(a){var c=this.getMatrix(this._origTransform);this.pan(c[4],c[5],b(a))},getTransform:function(){var b=this.elem,c=a.style(b,"transform");return this.isSVG&&!c?c=a.attr(b,"transform"):"none"===c||j.test(c)||(c=a.style(b,"transform",a.css(b,"transform"))),c||"none"},getMatrix:function(a){var b=j.exec(a||this.getTransform());return b&&b.shift(),b||[1,0,0,1,0,0]},setMatrix:function(b,c){if(!this.disabled){c||(c={}),"string"==typeof b&&(b=this.getMatrix(b));var d,e,f,g,h,i=+b[0];return(d="undefined"!=typeof c.contain?c.contain:this.options.contain)&&(e="invert"===d,f=this.container,g=this.dimensions,h=(g.width*i-f.width)/2+(f.width-g.width)/2,b[4]=Math[e?"max":"min"](Math[e?"min":"max"](b[4],h-g.left),-h-g.left),h=(g.height*i-f.height)/2+(f.height-g.height)/2,b[5]=Math[e?"max":"min"](Math[e?"min":"max"](b[5],h-g.top),-h-g.top)),"skip"!==c.animate&&this.transition(!c.animate),c.range&&this.$zoomRange.val(i),a[this.isSVG?"attr":"style"](this.elem,"transform","matrix("+b.join(",")+")"),c.silent||this._trigger("change",b),b}},isPanning:function(){return this.panning},transition:function(b){var c=b||!this.options.transition?"none":this._transition;a.style(this.elem,"transition",c)},pan:function(a,b,c){c||(c={});var d=c.matrix;d||(d=this.getMatrix()),c.relative?(d[4]=+d[4]+a,d[5]=+d[5]+b):(d[4]=a,d[5]=b),this.setMatrix(d,c),c.silent||this._trigger("pan",a,b)},zoom:function(a,b){var c=!1,d=this.options;if(!d.disableZoom){"object"==typeof a?(b=a,a=null):b||(b={});var e=this.getMatrix(),f=b.middle;f&&(e[4]=+e[4]+(f.pageX===e[4]?0:f.pageX>e[4]?1:-1),e[5]=+e[5]+(f.pageY===e[5]?0:f.pageY>e[5]?1:-1)),"number"!=typeof a&&(a=+e[0]+d.increment*(a?-1:1),c=!0),a>d.maxScale?a=d.maxScale:a<d.minScale&&(a=d.minScale),e[0]=a,e[3]="number"==typeof b.dValue?b.dValue:a,this.setMatrix(e,{animate:"boolean"==typeof b.animate?b.animate:c,range:!b.noSetRange}),b.silent||this._trigger("zoom",a,b)}},option:function(b,c){var d;if(!b)return a.extend({},this.options);if("string"==typeof b){if(1===arguments.length)return this.options[b];d={},d[b]=c}else d=b;this._setOptions(d)},_setOptions:function(b){var c=this;a.each(b,function(b,d){switch(b){case"disablePan":c._resetStyle();case"disableZoom":case"$zoomIn":case"$zoomOut":case"$zoomRange":case"$reset":case"onStart":case"onChange":case"onZoom":case"onPan":case"onEnd":case"onReset":case"eventNamespace":c._unbind()}switch(c.options[b]=d,b){case"disablePan":c._initStyle();case"disableZoom":case"$zoomIn":case"$zoomOut":case"$zoomRange":case"$reset":case"onStart":case"onChange":case"onZoom":case"onPan":case"onEnd":case"onReset":case"eventNamespace":c._bind();break;case"cursor":a.style(c.elem,"cursor",d);break;case"minScale":c.$zoomRange.attr("min",d);break;case"maxScale":c.$zoomRange.attr("max",d);break;case"contain":c._buildContain();break;case"startTransform":c._buildTransform();break;case"duration":case"easing":c._buildTransition();case"transition":c.transition()}})},_initStyle:function(){this.options.disablePan||this.$elem.css("cursor",this.options.cursor);var b=this.$parent;if(b.length&&!a.nodeName(b[0],"body")){var c={overflow:"hidden"};"static"===b.css("position")&&(c.position="relative"),b.css(c)}},_resetStyle:function(){this.$elem.css({cursor:"",transition:""}),this.$parent.css({overflow:"",position:""})},_bind:function(){var b=this,c=this.options,d=c.eventNamespace,e="touchstart"+d+" mousedown"+d,f="touchend"+d+" click"+d,g={};if(a.each(["Start","Change","Zoom","Pan","End","Reset"],function(){var b=c["on"+this];a.isFunction(b)&&(g["panzoom"+this.toLowerCase()+d]=b)}),c.disablePan&&c.disableZoom||(g[e]=function(a){var d;("mousedown"===a.type?c.disablePan||1!==a.which:!(d=a.touches)||(1!==d.length||c.disablePan)&&2!==d.length)||(a.preventDefault(),a.stopPropagation(),b._startMove(a,d))}),this.$elem.on(g),!c.disableZoom){var h=this.$zoomIn,i=this.$zoomOut,j=this.$zoomRange,k=this.$reset;h.length&&i.length&&(h.on(f,function(a){a.preventDefault(),b.zoom()}),i.on(f,function(a){a.preventDefault(),b.zoom(!0)})),j.length&&(j.attr({min:c.minScale,max:c.maxScale,step:.05}).prop({value:this.getMatrix()[0]}),g={},g.mousedown=function(){b.transition(!0)},g["change"+d]=function(){b.zoom(+this.value,{noSetRange:!0})},j.on(g)),k.length&&k.on(f,function(a){a.preventDefault(),b.reset()})}},_unbind:function(){this.$elem.add(this.$zoomIn).add(this.$zoomOut).add(this.$reset).off(this.options.eventNamespace)},_buildTransform:function(){this._origTransform=this.options.startTransform||this.getTransform()},_buildTransition:function(){var a=this.options;this._transform&&(this._transition=this._transform+" "+a.duration+"ms "+a.easing)},_buildContain:function(){if(this.options.contain){var b=this.$parent;this.container={width:b.width(),height:b.height()};var c=this.elem,d=this.$elem;this.dimensions=this.isSVG?{left:c.getAttribute("x")||0,top:c.getAttribute("y")||0,width:c.getAttribute("width")||d.width(),height:c.getAttribute("height")||d.height()}:{left:a.css(c,"left",!0)||0,top:a.css(c,"top",!0)||0,width:d.width(),height:d.height()}}},_getDistance:function(a){var b=a[0],c=a[1];return Math.sqrt(Math.pow(Math.abs(c.pageX-b.pageX),2)+Math.pow(Math.abs(c.pageY-b.pageY),2))},_getMiddle:function(a){var b=a[0],c=a[1];return{pageX:(c.pageX-b.pageX)/2+b.pageX,pageY:(c.pageY-b.pageY)/2+b.pageY}},_trigger:function(a){this.$elem.triggerHandler("panzoom"+a,[this].concat(e.call(arguments,1)))},_startMove:function(b,c){var d,e,f,g,h,i,j=this,k=this.options,l="touchstart"===b.type,m=k.eventNamespace,n=(l?"touchmove":"mousemove")+m,o=(l?"touchend":"mouseup")+m,p=this.getMatrix(),q={matrix:p,animate:"skip"},r=p.slice(0),s=+r[4],t=+r[5];this.transition(!0),this.panning=!0,this._trigger("start",b,c),c&&2===c.length?(e=this._getDistance(c),f=+p[0],g=this._getMiddle(c),d=function(a){a.preventDefault();var b=j._getMiddle(c=a.touches);j.pan(s+b.pageX-g.pageX,t+b.pageY-g.pageY,q);var d=j._getDistance(c)-e;j.zoom(d/300+f,{middle:b})}):(h=b.pageX,i=b.pageY,d=function(a){a.preventDefault(),j.pan(s+a.pageX-h,t+a.pageY-i,q)}),a(document).off(m).on(n,d).on(o,function(b){b.preventDefault(),a(this).off(m),j.panning=!1,j._trigger("end",p,!!a(r).not(p).length)})}},a.fn.panzoom=function(b){var c,f,g,h;return"string"==typeof b?(h=[],f=e.call(arguments,1),this.each(function(){c=a.data(this,d),c?"_"!==b.charAt(0)&&"function"==typeof(g=c[b])&&void 0!==(g=g.apply(c,f))&&h.push(g):h.push(void 0)}),h.length?1===h.length?h[0]:h:this):this.each(function(){new k(this,b)})},k});